#include "Graphics.h"
#include <math.h>
#include <time.h>

/*
  Random Walk example
  Nicolaas E. Groeneboom, FYS4150 H06
  leuat@irio.co.uk
  http://www.irio.co.uk
*/


Graphics g;
int W = 400; // Width
int H = 400;  // Height

// What happens if N goes to infinity? Try with N = 10 000, N = 200 000.. etc

int N = 10000;



int main(int a, char *b[])
{
  // Opens a window
  g.openWindow("Simplest random walk.",W,H);

  // Initializes random variable
  srand ( time(NULL) );  
  
  // Allocate memory for walkers: X and Y

  int* x = new int[N]; //x-pos 
  int* y = new int[N];//y-pos


  // Initialize all drunks at center
  for (int i=0;i<N;i++) {
           x[i] = 0;
           y[i] = 0;
      }


  // This variable takes care of events
  SDL_Event event;

  bool quit = false;
  while(!quit)
    {

      // iterates one random walk
      for (int i=0;i<N;i++) {
          
	int verdi=1;
          if (rand()%100<50) verdi = -verdi;

          if (rand()%100<50) {// up-down
            x[i] = x[i] + verdi;
	  }
          else
            y[i] = y[i] + verdi; 
            
      }   



      // Clears the screen (0=black, 255=white)
      g.Clear(0);

      // Draws the pixels: One pixel pr drunkard (g.pixel, g.largepixel, g.largestpixel) 
      for (int i=0;i<N;i++) {
	g.largestpixel(x[i] + W/2,y[i] + H/2,100,255,255);
      }
      
      // present to the screen (flip)
      g.flip();

      
      // Check for events (like keypressed)
      while ( SDL_PollEvent(&event) ) {
	        switch (event.type) {
 	              case SDL_QUIT:
	                   quit=true;
                  case SDL_KEYDOWN:
	                   quit=true; // Destroy 
	  
            }   
      }
    }

  // Clean memory
  delete[] x;
  delete[] y;
  return 0;
}
